--[[ 
  
Things to implement:

C_WowTokenPublic.UpdateMarketPrice()

C_WowTokenPublic.GetGuaranteedPrice()

Paper Doll functions

CanCancelScene()
CancelScene()
InCinematic()
IsInCinematicScene()
MouseOverrideCinematicDisable()
OpeningCinematic()
StopCinematic()

Currency - List current quantities of all currency with /vgs currency

Add UI

Recruit-a-Friend things

Use /vgs dung for auto Group Finder
use /vgs raid for auto Raid Finder

Auto Create Macros

GetNetStats() - Notify of high ping with timer
C_Timer.After(duration, callback) - Runs callback after given duration.
UI C_Timer.NewTimer(duration, callback) - Runs callback after given duration. (Cancelable)
UI C_Timer.NewTicker(duration, callback [, iterations]) - Runs callback multiple times iterating every given duration. (Cancelable)

Anti Trade Scam Alert?
GetPlayerTradeMoney() - Returns the amount of money the player has in the trade window.
GetTargetTradeMoney() - Returns the amount of money in the trade frame of the target player.

Change game Font?

Hunter Stable things
GetNumStablePets() - Returns the amount of stable pets.
GetNumStableSlots() - Returns the amount of stable slots.

VGSCharacterVar = 0 -- Reset VGSCharacterVar count to 0 after showing previous levelups.

]]

--[[
-- NetStats + timer
local SentData = select(1, GetNetStats()) or 0
local ReceivedData = select(2, GetNetStats()) or 0
local latencyHome = select(3, GetNetStats()) or 0
local latencyWorld = select(4, GetNetStats()) or 0
local function NetStats()
  local bandwidthIn, bandwidthOut, latencyHome, latencyWorld = GetNetStats()
  ChatFrame1:AddMessage("Your Latency: " .. latencyHome .. " ms, World Latency: " .. latencyWorld .. " ms.")
  local myTimer = C_Timer.After(15, NetStats())
end
]]--

local SentData = select(1, GetNetStats()) or 0
local ReceivedData = select(2, GetNetStats()) or 0
local latencyHome = select(3, GetNetStats()) or 0
local latencyWorld = select(4, GetNetStats()) or 0
local id, name, mult = GetRestState()
local LoginFrame = CreateFrame("Frame")
LoginFrame:RegisterEvent("PLAYER_LOGIN")
LoginFrame:SetScript("OnEvent", function(self, event, ...)
        if type(VGSSavedVar) ~= "number" then -- If variable is NOT a number, set it to 1 for login counter.
                VGSSavedVar = 1
         elseif type(VGSCharacterVar) ~= "number" then
                  VGSCharacterVar = 0 -- If this is the first time this addon has loaded, set VGSCharacterVar variable count to 0 for previous levelups.
                ChatFrame1:AddMessage("VGS Addon Loaded",1,0.5,0)
                ChatFrame1:AddMessage("Welcome ".. UnitName("Player")..". This is your first time logging in with the VGS Addon!",1,0.5,0)
                ChatFrame1:AddMessage("Your Latency: " .. latencyHome .. " ms. World Latency: " .. latencyWorld .. " ms.",1,0.5,0)
         else
                if VGSSavedVar == 1 then
                  ChatFrame1:AddMessage("VGS Addon Loaded",1,0.5,0)
                  ChatFrame1:AddMessage("Welcome back ".. UnitName("Player").. ". Enjoy using the VGS Addon again!",1,0.5,0)
                  ChatFrame1:AddMessage("Your Latency: " .. latencyHome .. " ms. World Latency: " .. latencyWorld .. " ms.",1,0.5,0)
                else
                  ChatFrame1:AddMessage("VGS Addon Loaded",1,0.5,0)
                  ChatFrame1:AddMessage("Welcome back ".. UnitName("Player").. ". You have logged in with the VGS Addon enabled " .. VGSSavedVar .. " times!",1,0.5,0)
                  ChatFrame1:AddMessage("Your Latency: " .. latencyHome .. " ms. World Latency: " .. latencyWorld .. " ms.",1,0.5,0)
                end
                VGSSavedVar = VGSSavedVar + 1 -- Add 1 to Login counter
        end
        -- Rested XP + Previous session levelup counter
        -- GetXPExhaustion() Returns retVal Number (if player is "rested"), nil (if player is "normal")
        -- GetRestState() Returns 1 = rested / 2 = not rested
        if GetXPExhaustion() ~= nil then
          ChatFrame1:AddMessage("You now have " .. GetXPExhaustion() .. " rested XP to use!",1,0.5,0)
          ChatFrame1:AddMessage("You gained " .. VGSCharacterVar .. " levels last session.",1,0.5,0)
        elseif UnitLevel("Player") == 120 then
        -- do nothing
        else
        ChatFrame1:AddMessage("You're not rested. Try logging out in a city or inn next time!",1,0.5,0)
        ChatFrame1:AddMessage("You gained " .. VGSCharacterVar .. " levels last session.",1,0.5,0)
        end
end)

-- Levelup Tracker
local LevelUp_EventFrame = CreateFrame("Frame")
LevelUp_EventFrame:RegisterEvent("PLAYER_LEVEL_UP")
LevelUp_EventFrame:SetScript("OnEvent", function(self, event, ...)
	local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9 = ...
  print("Congratulations, you are now level " .. arg1 .. "!")
  VGSCharacterVar = VGSCharacterVar + 1 -- Add 1 to levelup counter
end)

-- Auto Resurection Accepter
local AutoAcceptResFrame = CreateFrame("Frame")
AutoAcceptResFrame:RegisterEvent("RESURRECT_REQUEST")
AutoAcceptResFrame:SetScript("OnEvent", function(self, event, ...)
	local function AutoResAccept(self, event, arg1, arg2, ...)
    if event == "RESURRECT_REQUEST" then
      AcceptResurrect()
      StaticPopup_Hide("RESURRECT_NO_TIMER")
    end
  end
end)

-- Auto Summon Accepter
local AutoAcceptSummonFrame = CreateFrame("Frame")
AutoAcceptSummonFrame:RegisterEvent("CONFIRM_SUMMON")
AutoAcceptSummonFrame:SetScript("OnEvent", function(self, event, ...)
	local function AutoSummonAccept(self, event, arg1, arg2, ...)
    if event == "CONFIRM_SUMMON" then
      StaticPopup_Hide("CONFIRM_SUMMON")
      C_SummonInfo.ConfirmSummon()
    end
  end
end)

-- Auto Revive at corpse
local AutoCorpseReviveFrame = CreateFrame("Frame")
AutoCorpseReviveFrame:RegisterEvent("PLAYER_DEAD")
AutoCorpseReviveFrame:SetScript("OnEvent", function(self, event, ...)
	local function AutoCorpseRevive(self, event, arg1, arg2, ...)
    if event == "CORPSE_IN_RANGE" then
      RetrieveCorpse()
    end
  end
end)

-- / Slash commands
local function MyAddonCommands(msg, editbox)
    if msg == "str" then
        local base, stat, posBuff, negBuff = UnitStat("player",1);
      print("Your current Strength is ".. stat);
    elseif msg == "agi" then
        local base, stat, posBuff, negBuff = UnitStat("player",2);
      print("Your current Agility is ".. stat);
    elseif msg == "stam" then
        local base, stat, posBuff, negBuff = UnitStat("player",3);
      print("Your current Stamina is ".. stat);
    elseif msg == "int" then
        local base, stat, posBuff, negBuff = UnitStat("player",4);
      print("Your current Intellect is ".. stat);
    elseif msg == "IntVer" then
      ChatFrame1:AddMessage("Game Version:",1,0.5,0)
      ChatFrame1:AddMessage((select(4, GetBuildInfo())),1,1,0)
    elseif msg == "def" then
      local b,d,p,r,a=GetBlockChance(),GetDodgeChance(),GetParryChance(),GetCombatRating(CR_DEFENSE_SKILL) a=1/(.0625+.956/(r/122.9625)) ChatFrame1:AddMessage(format("Defensive Stats:\nUnhittable %.2f%% of the time.\nAvoidance: %.2f%%\nDefense %+.0f rating",b+d+p+5+a,d+p+5+a,r-689),1,0.5,0)
    else
      ChatFrame1:AddMessage("Possible uses: /vgs str, /vgs agi, /vgs stam, /vgs int.\n/vgs def (shows defence rating), /vgs IntVer (shows interface version).",1,0.5,0)
    end
  end
  
  SLASH_VGS1 = "/vgs"
  SlashCmdList["VGS"] = MyAddonCommands   -- add slash commands to list